
-- 01. create pflow_table
create table pflow_table_pid_2000 (
  pid       integer,
  tripid    integer,
  subtripid integer,
  starttime timestamp with time zone,
  lon       double precision,
  lat       double precision,
  gender    integer,
  age       integer,
  address   varchar(10),
  work      integer,
  purpose   integer,
  magfac1   integer,
  magfac2   integer,
  transport integer
);

-- copy from csv file to DB table(pflow_table_0000)
copy pflow_table_0000 from 'sample_pid_based.csv' (delimiter ',', format csv,header false);

-- create additional geometry column to pflow_table
alter table pflow_table_pid_2000 add column geom geometry('POINT',4326);

-- create POINT geometry from (lon,lat) position and set it to geometry column
update pflow_table_pid_2000 set geom=ST_SetSrid(ST_MakePoint(lon,lat),4326);

-- 空間インデックス作成(Gist)
create index idx_pflow_table_pid_2000_geom    on pflow_table_pid_2000 using Gist(geom);

-- 10:00に東京駅周辺にいる人検索
select 
  * 
from 
  pflow_table_pid_2000
where
  time='2008-10-01 10:00:00' and 
  ST_Intersects(
      geom,
      ST_SetSRID(
        ST_MakeBox2D(
          ST_MakePoint(139.76325989,35.67870325),
          ST_MakePoint(139.76948261,35.68320008)
        ),
        4326
      )
  )
;